//@flow

import {reduce, flatMap, map, range} from 'lodash'
// import reduce from 'lodash/reduce'
// import flatMap from 'lodash/flatMap'
// import map from 'lodash/map'
// import range from 'lodash/range'


export function assert(cond: any, msg: string) {
    if (!cond) {
        throw new Error(msg)
    }
}

export function cartesianProduct<T>(...args: Array<Array<T>>): Array<Array<T>> {
    return reduce(
        args,
        (acc, val) => flatMap(
            acc,
            a => map(
                val,
                v => [].concat(a, v)
            )
        )
    )
}
